DATE: 4/2/86
FROM: ERIC H. FRANKEL
RE:   PATCHES FOR COM PORTS

The following method was successfully used to alter PROCOMM.EXE
to use COM3: and COM4: rather than COM1: and COM2:.  This was
done in order to use the program on a COMPAQ DESKPRO with two 
serial ports on an expansion board and an internal modem.  In order
to keep all ports active, the modem was configured with its jumpers
to be addressed as COM3:.

The steps outlined below worked with PROCOMM.EXE Version 2.3.  I
have also successfully altered PROCOMM.EXE Version 2.2 in a similar
fashion.  The DEBUG search command could be used to locate the 
appropriate sections of code and display messages using the
information in the script for Version 2.3 to alter prior versions and
it may work on future versions of PROCOMM and other communications
programs as well if an identical method is used to output data.

   1.  U 051E 0587  <CR>       ; This unassembles the section of
                               ; code which outputs data to the COM
                               ; ports.  The display should match the
                               ; output listed here.  If not this
                               ; patch won't work.
 
       CS:051E 55              PUSH    BP
       CS:051F 8BEC            MOV     BP,SP
       CS:0521 C7065D7D0B00    MOV     WORD PTR [7D5D],000B
       CS:0527 C706A77DFB02    MOV     WORD PTR [7DA7],02FB
       CS:052D C706AD7DFC02    MOV     WORD PTR [7DAD],02FC
       CS:0533 C706AF7DFE02    MOV     WORD PTR [7DAF],02FE
       CS:0539 C706B57DFD02    MOV     WORD PTR [7DB5],02FD
       CS:053F C706BD7DF802    MOV     WORD PTR [7DBD],02F8
       CS:0545 C706C57DF902    MOV     WORD PTR [7DC5],02F9
       CS:054B C706CB7DF802    MOV     WORD PTR [7DCB],02F8
       CS:0551 5D              POP     BP
       CS:0552 C3              RET
       CS:0553 55              PUSH    BP
       CS:0554 8BEC            MOV     BP,SP
       CS:0556 C7065D7D0C00    MOV     WORD PTR [7D5D],000C
       CS:055C C706A77DFB03    MOV     WORD PTR [7DA7],03FB
       CS:0562 C706AD7DFC03    MOV     WORD PTR [7DAD],03FC
       CS:0568 C706AF7DFE03    MOV     WORD PTR [7DAF],03FE
       CS:056E C706B57DFD03    MOV     WORD PTR [7DB5],03FD
       CS:0574 C706BD7DF803    MOV     WORD PTR [7DBD],03F8
       CS:057A C706C57DF903    MOV     WORD PTR [7DC5],03F9
       CS:0580 C706CB7DF803    MOV     WORD PTR [7DCB],03F8
       CS:0586 5D              POP     BP
       CS:0587 C3              RET
                               ; The value for CS will differ from
                               ; machine to machine.
   2.  E CS:052B EB <CR>
       E CS:0531 EC <CR>
       E CS:0537 EE <CR>
       E CS:053D ED <CR>
       E CS:0543 E8 <CR>
       E CS:0549 E9 <CR>
       E CS:054F E8 <CR>
       E CS:0560 EB <CR>
       E CS:0566 EC <CR>
       E CS:056C EE <CR>
       E CS:0572 ED <CR>
       E CS:0578 E8 <CR>
       E CS:057E E9 <CR>
       E CS:0584 E8 <CR>       ; This changes the functioning of the
                               ; program.
   3.  Add 1000H to the value on your equipment for CS and use this
       as the segment address.

       E (CS + 1000H):85CB 34 <CR>
       E (CS + 1000H):85D0 33 <CR>
       E (CS + 1000H):8601 34 <CR>
       E (CS + 1000H):8606 33 <CR>
       E (CS + 1000H):BE49 33 <CR>
       E (CS + 1000H):BE57 34 <CR>
       E (CS + 1000H):C0A8 33 <CR>
       E (CS + 1000H):C0AC 34 <CR>
                               ; This alters all display references
                               ; from COM1: and COM2: to COM3: and
                               ; COM4: respectively.
   4.  W                       ; This writes the changes back to
                               ; diskette to save them.
   5.  Q                       ; This ends the DEBUG session.
   6.  REN PROCOMM.XXX PROCOMM.EXE
   7.  Run PROCOMM to check it out.

This method was developed using the search command to locate the
memory addresses used for COM1: and COM2:, then unassembling the
code in the parts of the program containing the memory designations
(03F8 to 03FF and 02F8 to 02FF) sought.  The original search included
all the segments used by the program.  Then a similar search was done
to find all display references to the strings "COM1" and COM2".  This
strategy may have more general applications with other communication
software.

HAPPY HACKING
